##############################################################################
# $Id: connection_poller_thread.py,v 1.4 2003/06/12 14:06:59 churchil Exp $
##############################################################################

from connection import Connection
from threading import *
from select import select
import pygame
from pygame.locals import *

import sys
# import properties
# import scenario
import constants
import globals

class ConnectionPollerThread ( Thread ):
    """This class implements a thread that waits for data on a specific
    socket connection. It sends a USEREVENT with a code and
    a connection parameter. """
    
    def __init__(self, connection):
        """Initializes the thread. connection is the Connection that
        it will listen to"""
        Thread.__init__(self)
        self.connection = connection

        # allow the event we will use for notification
        pygame.event.set_allowed ( USEREVENT )


    def run (self):
        """Starts and runs the thread"""

        print "Starting connection poller thread"

        while 1:
            # We block with a timeout value
            # so we can detect when the game has ended
            try:
                incoming, out, exceptional = select ( [ self.connection ], [], [], 1.000 )
            except ValueError:
                # hmm, seems the other party has died?
                globals.playing       = constants.GAME_ENDED
                # scenario.end_game_type = constants.OPPONENT_CRASH

                # terminate ourselves
                break
            
            # Should we quit?
            # if scenario.playing == constants.GAME_ENDED:
                # break
            
            # Did we get anything?
            if len(incoming) == 0:
                continue

            # Create a new event
            #print "Posting event"
            try:
                e = pygame.event.Event(pygame.USEREVENT, { "code": constants.USEREVENT_SOCKET_DATA,
                                                           "connection": self.connection })
                # Send it to the main event loop
                pygame.event.post(e)
            except:
				# Something broke badly, exit
				print "shutting down, got exception", sys.exc_info()[0]
				globals.playing = constants.GAME_ENDED
				break

            # Just in case, also gives time for the main loop to read the packets
            pygame.time.wait (10)

        print "Stopping connection poller thread"

