#!/usr/bin/python 

#######################################################################
# $Id: pytego-server.py,v 1.4 2003/06/20 16:09:03 churchil Exp $
#######################################################################


import sys, string, getopt
from socket import *
from threading import *

CLIENTS = {}
QUEUE = []

class ServerThread(Thread):
	def __init__(self, addr, sock):
		Thread.__init__(self)
		self.addr = addr
		self.sock = sock

	def run(self):
		file = self.sock.makefile('r')
		while 1:
			data = string.strip(file.readline())
			if not data:
				print 'shutting down...'
				break
			else:
				QUEUE.append((self.addr,data))
		
		self.sock.close()
		del CLIENTS[self.addr]

def printUsage():
	""" seperate options with 2 tabs """
	print "\n \
Usage: pytego-server [options] \n \
\n \
-h, --help		Print this text and exit\n \
-H, --host <host>	Use hostname (Default: localhost) \n \
-p, --port <port>	Use other port (Default: 9998) \n \
		"

def main(argv):
	try:
		opts, args = getopt.getopt(argv, "hp:H:f", ["help", "port=", "host=", "run-forever"])
	except getopt.GetoptError:
		sys.exit(2)

	host = ''
	port = 9998
	run_forever = 1

	for opt, arg in opts:
		if opt in ("-h", "--help"):
			printUsage()
			sys.exit(1)
		elif opt in ("-p", "--port"):
			port = int(arg)
		elif opt in ("-h", "--host"):
			host = arg
		elif opt in ("-f", "--run-forever"):
			run_forever = 2

	sock = socket(AF_INET, SOCK_STREAM)
	sock.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
	try:
		sock.bind((host, port))
	except:
		print 'error binding, already in use'
		sys.exit(1)

	while run_forever:
		run_forever -= 1 # cheesy, but it works
		while len(CLIENTS) != 2:
			print 'waiting for %d client(s) to connect...' % (2-len(CLIENTS))
			sock.listen(2)
			newsock, addr = sock.accept()
			CLIENTS[addr] = newsock

		print 'all clients connected', CLIENTS

		for c in CLIENTS:
			ServerThread(c, CLIENTS[c]).start()

		while len(CLIENTS) == 2:
			# tick, tick
			if len(QUEUE) > 0:
				data = QUEUE.pop(0)
				fromClient = data[0]
				msg = data[1]

				for c in CLIENTS:
					if c != fromClient:
						# print 'sending %s from %s to %s' % (msg, fromClient, c)
						CLIENTS[c].send(msg+'\n')
	
	sock.close()


if __name__ == "__main__":
	main(sys.argv[1:])
